## fish 3.6.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

if(POLICY CMP0066)
  cmake_policy(SET CMP0066 OLD)
endif()
if(POLICY CMP0067)
  cmake_policy(SET CMP0067 NEW)
endif()

include(cmake/Mac.cmake)

project(fish)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# We are C++11.
set(CMAKE_CXX_STANDARD 11)
set(DEFAULT_BUILD_TYPE "RelWithDebInfo")

# Generate Xcode schemas (but not for tests).
set(CMAKE_XCODE_GENERATE_SCHEME 1)

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    message(STATUS "Setting build type to default '${DEFAULT_BUILD_TYPE}'")
    set(CMAKE_BUILD_TYPE "${DEFAULT_BUILD_TYPE}")
endif()

# Error out when linking statically, it doesn't work.
if (CMAKE_EXE_LINKER_FLAGS MATCHES ".*-static.*")
    message(FATAL_ERROR "Fish does not support static linking")
endif()

# Force colored warnings in Ninja's output, if the compiler has -fdiagnostics-color support.
# Rationale in https://github.com/ninja-build/ninja/issues/814
if (CMAKE_GENERATOR STREQUAL "Ninja" AND
    ((CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.9) OR
     (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.5) OR
     (CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang" AND NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 6.0)))
      add_compile_options(-fdiagnostics-color=always)
endif()

# Enable a whole bunch of warnings, but turn off:
# - comment because we use a bunch of those, and they're not really all that harmful.
# - address, because that occurs for our mkostemp check (weak-linking requires us to compare `&mkostemp == nullptr`).
add_compile_options(-Wall -Wextra -Wno-comment -Wno-address)

if ((CMAKE_CXX_COMPILER_ID STREQUAL "Clang") OR (CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang"))
  add_compile_options(-Wunused-template -Wunused-local-typedef -Wunused-macros)
endif()

# Disable exception handling.
add_compile_options(-fno-exceptions)

# Undefine NDEBUG to keep assert() in release builds.
add_definitions(-UNDEBUG)

# Enable large files on GNU.
add_definitions(-D_LARGEFILE_SOURCE
                -D_LARGEFILE64_SOURCE
                -D_FILE_OFFSET_BITS=64
                -D_ATFILE_SOURCE)

# Hide the CMake Rules directories in Xcode projects.
source_group("CMake Rules" REGULAR_EXPRESSION "^$")

# Put source and header files at top level under targets.
source_group("Source Files" REGULAR_EXPRESSION ".*\\.cpp")
source_group("Header Files" REGULAR_EXPRESSION ".*\\.h")
source_group("Builtins" "builtins/")

# Support folders.
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

# Work around issue where archive-built libs go in the wrong place.
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")

if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_CURRENT_BINARY_DIR)
  set(FISH_IN_TREE_BUILD TRUE)
else()
  set(FISH_IN_TREE_BUILD FALSE)
endif()

# NetBSD does weird things with finding libraries,
# making the tests fail by failing to find pcre.
#
# Keep the rpath used to build.
if(CMAKE_SYSTEM_NAME STREQUAL NetBSD)
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
endif()

# List of sources for builtin functions.
set(FISH_BUILTIN_SRCS
    src/builtin.cpp src/builtins/abbr.cpp src/builtins/argparse.cpp
    src/builtins/bg.cpp src/builtins/bind.cpp src/builtins/block.cpp
    src/builtins/builtin.cpp src/builtins/cd.cpp src/builtins/command.cpp
    src/builtins/commandline.cpp src/builtins/complete.cpp src/builtins/contains.cpp
    src/builtins/disown.cpp src/builtins/echo.cpp src/builtins/emit.cpp
    src/builtins/eval.cpp src/builtins/exit.cpp src/builtins/fg.cpp
    src/builtins/function.cpp src/builtins/functions.cpp src/builtins/history.cpp
    src/builtins/jobs.cpp src/builtins/math.cpp src/builtins/printf.cpp src/builtins/path.cpp
    src/builtins/pwd.cpp src/builtins/random.cpp src/builtins/read.cpp
    src/builtins/realpath.cpp src/builtins/return.cpp src/builtins/set.cpp
    src/builtins/set_color.cpp src/builtins/source.cpp src/builtins/status.cpp
    src/builtins/string.cpp src/builtins/test.cpp src/builtins/type.cpp src/builtins/ulimit.cpp
    src/builtins/wait.cpp)

# List of other sources.
set(FISH_SRCS
    src/ast.cpp src/abbrs.cpp src/autoload.cpp src/color.cpp src/common.cpp src/complete.cpp
    src/env.cpp src/env_dispatch.cpp src/env_universal_common.cpp src/event.cpp
    src/exec.cpp src/expand.cpp src/fallback.cpp src/fd_monitor.cpp src/fish_version.cpp
    src/flog.cpp src/function.cpp src/future_feature_flags.cpp src/highlight.cpp
    src/history.cpp src/history_file.cpp src/input.cpp src/input_common.cpp
    src/io.cpp src/iothread.cpp src/job_group.cpp src/kill.cpp
    src/null_terminated_array.cpp src/operation_context.cpp src/output.cpp
    src/pager.cpp src/parse_execution.cpp src/parse_tree.cpp src/parse_util.cpp
    src/parser.cpp src/parser_keywords.cpp src/path.cpp src/postfork.cpp
    src/proc.cpp src/re.cpp src/reader.cpp src/redirection.cpp src/screen.cpp
    src/signal.cpp src/termsize.cpp src/timer.cpp src/tinyexpr.cpp
    src/tokenizer.cpp src/topic_monitor.cpp src/trace.cpp src/utf8.cpp src/util.cpp
    src/wait_handle.cpp src/wcstringutil.cpp src/wgetopt.cpp src/wildcard.cpp 
    src/wutil.cpp src/fds.cpp
)

# Header files are just globbed.
file(GLOB FISH_HEADERS src/*.h)

# Set up config.h
include(cmake/ConfigureChecks.cmake)
include(cmake/gettext.cmake)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config_cmake.h.in
               ${CMAKE_CURRENT_BINARY_DIR}/config.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

# Set up standard directories.
include(GNUInstallDirs)
add_definitions(-D_UNICODE=1
                -DLOCALEDIR="${CMAKE_INSTALL_FULL_LOCALEDIR}"
                -DPREFIX=L"${CMAKE_INSTALL_PREFIX}"
                -DDATADIR=L"${CMAKE_INSTALL_FULL_DATADIR}"
                -DSYSCONFDIR=L"${CMAKE_INSTALL_FULL_SYSCONFDIR}"
                -DBINDIR=L"${CMAKE_INSTALL_FULL_BINDIR}"
                -DDOCDIR=L"${CMAKE_INSTALL_FULL_DOCDIR}")

# Set up the machinery around FISH-BUILD-VERSION-FILE
# This defines the FBVF variable.
include(Version)

# Let fish pick up when we're running out of the build directory without installing
get_filename_component(REAL_CMAKE_BINARY_DIR "${CMAKE_BINARY_DIR}" REALPATH)
get_filename_component(REAL_CMAKE_SOURCE_DIR "${CMAKE_SOURCE_DIR}" REALPATH)
add_definitions(-DCMAKE_BINARY_DIR="${REAL_CMAKE_BINARY_DIR}")
add_definitions(-DCMAKE_SOURCE_DIR="${REAL_CMAKE_SOURCE_DIR}")

# Teach fish_version.o to rebuild when FBVF changes.
# The standard C++ include detection machinery misses this.
set_source_files_properties(src/fish_version.cpp
                            PROPERTIES OBJECT_DEPENDS
                            ${CMAKE_CURRENT_BINARY_DIR}/${FBVF})

# Enable thread-safe errno on Solaris (#5611)
add_definitions(-D_REENTRANT)

# Set up PCRE2
include(cmake/PCRE2.cmake)

# Define a function to link dependencies.
function(FISH_LINK_DEPS_AND_SIGN target)
  target_link_libraries(${target} fishlib)
  codesign_on_mac(${target})
endfunction(FISH_LINK_DEPS_AND_SIGN)

# Define libfish.a.
add_library(fishlib STATIC ${FISH_SRCS} ${FISH_BUILTIN_SRCS})
target_sources(fishlib PRIVATE ${FISH_HEADERS})
target_link_libraries(fishlib
  ${CURSES_LIBRARY} ${CURSES_EXTRA_LIBRARY} Threads::Threads ${CMAKE_DL_LIBS}
  ${PCRE2_LIB} ${Intl_LIBRARIES} ${ATOMIC_LIBRARY})
target_include_directories(fishlib PRIVATE
  ${CURSES_INCLUDE_DIRS})

# Define fish.
add_executable(fish src/fish.cpp)
fish_link_deps_and_sign(fish)

# Define fish_indent.
add_executable(fish_indent
               src/fish_indent.cpp src/print_help.cpp)
fish_link_deps_and_sign(fish_indent)

# Define fish_key_reader.
add_executable(fish_key_reader
               src/fish_key_reader.cpp src/print_help.cpp)
fish_link_deps_and_sign(fish_key_reader)

# Set up the docs.
include(cmake/Docs.cmake)

# A helper for running tests.
add_executable(fish_test_helper src/fish_test_helper.cpp)

# Set up tests.
include(cmake/Tests.cmake)

# Benchmarking support.
include(cmake/Benchmark.cmake)

# Set up install.
include(cmake/Install.cmake)

# Mac app.
include(cmake/MacApp.cmake)

# ThreadSanitizer likes to muck with signal handlers, which interferes
# with fish_test_helper printing the ignored signal mask.
# Ensure fish_test_helper does not use TSan.
# Note the environment var is CXXFLAGS, but the CMake var is CMAKE_CXX_FLAGS.
if (CMAKE_CXX_FLAGS MATCHES ".*-fsanitize=thread.*")
  target_compile_options(fish_test_helper PRIVATE "-fno-sanitize=all")
  target_link_libraries(fish_test_helper "-fno-sanitize=all")
endif()

# Lint targets
# This could be implemented as target properties, but the script has the useful feature of only
# checking the currently-staged commands
# The generator expressions below rebuild the command line for the fishlib targets
# CMake does not support the "iquote" flag - https://gitlab.kitware.com/cmake/cmake/issues/15491
set(LINT_ARGS "-D$<JOIN:$<TARGET_PROPERTY:fishlib,COMPILE_DEFINITIONS>, -D>" "-I$<JOIN:$<TARGET_PROPERTY:fishlib,INCLUDE_DIRECTORIES>, -I>")
add_custom_target(lint
    COMMAND build_tools/lint.fish -p ${CMAKE_BINARY_DIR} -- ${LINT_ARGS}
    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
)
add_custom_target(lint-all
    COMMAND build_tools/lint.fish --all -p ${CMAKE_BINARY_DIR} -- ${LINT_ARGS}
    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
)

include(FeatureSummary)
feature_summary(WHAT ALL)

=== debian/changelog ===
fish (3.6.0-3.1+deb12u1) bookworm; urgency=medium

  * Cherry-pick upstream fix for CVE-2023-49284. (Closes: #1057455)
    fish shell uses certain Unicode non-characters internally for marking
    wildcards and expansions. It will incorrectly allow these markers to be
    read on command substitution output, rather than transforming them into
    a safe internal representation.

 -- Mo Zhou <lumin@debian.org>  Thu, 21 Dec 2023 14:47:56 -0500

fish (3.6.0-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Apply an upstream workaround for Midnight Commander's issue with prompt.
    See https://github.com/fish-shell/fish-shell/pull/9540 and #1000351.
    Closes: #1035353.

 -- Andrej Shadura <andrewsh@debian.org>  Mon, 01 May 2023 19:01:01 +0200

fish (3.6.0-3) unstable; urgency=medium

  * Cherry-pick upstream fixes from the v3.6.1 branch.
  * Add the missing Depends on procps (Closes: #1029940).

 -- Mo Zhou <lumin@debian.org>  Sat, 25 Mar 2023 10:20:50 -0400

fish (3.6.0-2) unstable; urgency=medium

  * Ignore several flaky tests for armel.

 -- Mo Zhou <lumin@debian.org>  Fri, 17 Feb 2023 20:05:29 -0500

fish (3.6.0-1) unstable; urgency=medium

  * New upstream version 3.6.0 (Jan 2023)

 -- Mo Zhou <lumin@debian.org>  Sat, 07 Jan 2023 11:39:49 -0500

fish (3.5.1+ds-2) unstable; urgency=medium

  * Move `lynx | www-browser` from Depends to Recommends. (Closes: #1017464)
  * Track version via fishshell.com instead of the broken GitHub.

 -- Mo Zhou <lumin@debian.org>  Tue, 13 Dec 2022 12:01:14 -0500

=== debian/control ===
Source: fish
Section: shells
Priority: optional
Maintainer: Tristan Seligmann <mithrandi@debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               gettext,
               libncurses-dev,
               libpcre2-dev,
               locales-all <!nocheck>,
               ninja-build,
               procps <!nocheck>,
               python3 <!nocheck>,
               python3-sphinx,
               python3-pexpect <!nocheck>,
Standards-Version: 4.6.0
Homepage: http://fishshell.com/
Vcs-Browser: https://salsa.debian.org/debian/fish
Vcs-Git: https://salsa.debian.org/debian/fish.git
Rules-Requires-Root: no

Package: fish
Architecture: any
Depends: fish-common (= ${source:Version}),
         bsdextrautils,
         groff-base,
         man-db,
         procps,
         python3,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: xsel, lynx | www-browser,
Suggests: doc-base
Description: friendly interactive shell
 Fish is a shell geared towards interactive use.  Its features are focused on
 user friendliness and discoverability.  The language syntax is simple but
 incompatible with other shell languages.

Package: fish-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: fish
Description: friendly interactive shell (architecture-independent files)
 Fish is a shell geared towards interactive use.  Its features are focused on
 user friendliness and discoverability.  The language syntax is simple but
 incompatible with other shell languages.
 .
 This package contains the common fish files shared by all architectures.

=== debian/watch ===
version=4
opts="pgpsigurlmangle=s%$%.asc%,dversionmangle=s/\+ds$//,repacksuffix=+ds" \
   https://fishshell.com/ \
   (?:.*?)/fish-(\d[\d.]*)@ARCHIVE_EXT@ debian

## fish 3.6.1

=== debian/changelog ===
fish (3.6.1-1) unstable; urgency=medium

  [ David Adam ]
  * d/copyright: update to match reality

  [ Mo Zhou ]
  * New upstream version 3.6.1
  * Remove all patches (already in new release).
  * cme update dpkg-copyright (w/ manual edits).
  * Copoyright: add missing licenses.
  * Delete debian/NEWS.
    Even the oldoldstable version is newer than the latest NEWS entry now.
  * Recommend python3:any | python3-minimal:any for fish-common.
  * Update lintian overrides. We are lintian-clean.

 -- Mo Zhou <lumin@debian.org>  Sat, 17 Jun 2023 15:28:04 -0700

=== debian/control ===
--- 
+++ 
@@ -41,7 +41,7 @@
 Architecture: all
 Multi-Arch: foreign
 Depends: ${misc:Depends}
-Recommends: fish
+Recommends: fish, python3:any
 Description: friendly interactive shell (architecture-independent files)
  Fish is a shell geared towards interactive use.  Its features are focused on
  user friendliness and discoverability.  The language syntax is simple but

## fish 3.6.1-1~bionic+9.0trisquel1

=== debian/changelog ===
fish (3.6.1-1~bionic+9.0trisquel1) etiona-backports; urgency=medium

  * Updated from 2.x to 3.x release through backports

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Sat, 25 Mar 2023 12:40:13 +0000

fish (3.6.1-1~bionic) bionic; urgency=medium

  * Release of new version 3.6.1.

  See https://github.com/fish-shell/fish-shell/releases/tag/3.6.1 for
  significant changes.

 -- David Adam <zanchey@ucc.gu.uwa.edu.au>  Sat, 25 Mar 2023 17:22:12 +0800

fish (3.6.0-1) bionic; urgency=medium

  * Release of new version 3.6.0.

  See https://github.com/fish-shell/fish-shell/releases/tag/3.6.0 for
  significant changes.

 -- David Adam <zanchey@ucc.gu.uwa.edu.au>  Sat, 07 Jan 2023 22:41:32 +0800

fish (3.5.1-1) bionic; urgency=medium

  * Release of new version 3.5.1.

  See https://github.com/fish-shell/fish-shell/releases/tag/3.5.1 for
  significant changes.

 -- David Adam <zanchey@ucc.gu.uwa.edu.au>  Wed, 20 Jul 2022 21:54:09 +0800

fish (3.5.0-1) bionic; urgency=medium

  * Release of new version 3.5.0.

  See https://github.com/fish-shell/fish-shell/releases/tag/3.5.0 for
  significant changes.

 -- David Adam <zanchey@ucc.gu.uwa.edu.au>  Thu, 16 Jun 2022 19:45:33 +0800

fish (3.4.0-1) bionic; urgency=medium

  * Release of new version 3.4.0.

  See https://github.com/fish-shell/fish-shell/releases/tag/3.4.0 for
  significant changes.

 -- David Adam <zanchey@ucc.gu.uwa.edu.au>  Sat, 12 Mar 2022 23:24:22 +0800

fish (3.3.1-1) bionic; urgency=medium

  * Release of new version 3.3.1.

  See https://github.com/fish-shell/fish-shell/releases/tag/3.3.1 for
  significant changes.

 -- David Adam <zanchey@ucc.gu.uwa.edu.au>  Tue, 06 Jul 2021 23:22:36 +0800

=== debian/control ===
Source: fish
Section: shells
Priority: optional
Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
Uploaders: David Adam <zanchey@ucc.gu.uwa.edu.au>
# Debhelper should be bumped to >= 10 once Ubuntu Xenial is no longer supported
Build-Depends: debhelper (>= 9.20160115), libncurses5-dev, cmake (>= 3.5.0), gettext, libpcre2-dev,
# Test dependencies
 locales-all, python3
Standards-Version: 4.1.5
Homepage: https://fishshell.com/
Vcs-Git: https://github.com/fish-shell/fish-shell.git
Vcs-Browser: https://github.com/fish-shell/fish-shell

Package: fish
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, passwd (>= 4.0.3-10), gettext-base, man-db,
 procps, python3 (>=3.5)
Conflicts: fish-common
Recommends: xsel (>=1.2.0)
Suggests: xdg-utils
Description: friendly interactive shell
 Fish is a command-line shell for modern systems, focusing on user-friendliness,
 sensibility and discoverability in interactive use. The syntax is simple, but
 not POSIX compliant.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

%:
	dh $@

# Setting the build system is still required, because otherwise the GNUmakefile gets picked up
override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake

# On CMake 3.5 (and possibly 3.6), the test target does not pick up its dependencies properly
# Build fish_tests/tests_buildroot_target by hand (remove this once Ubuntu Xenial is out of support)
override_dh_auto_build:
	dh_auto_build -- all fish_tests tests_buildroot_target

## fish 3.7.0

=== debian/changelog ===
fish (3.7.0-1) unstable; urgency=medium

  * New upstream version 3.7.0
  * Specify CMAKE_BUILD_TYPE=RelWithDebInfo.

 -- Mo Zhou <lumin@debian.org>  Mon, 01 Jan 2024 12:28:54 -0500

fish (3.6.4-1) unstable; urgency=medium

  * New upstream version 3.6.4 (Closes: #1057455) (Fixes: CVE-2023-49284)
  * Make uploader the maintainer. (Closes: #1040969)
    Tristan has retired from Debian. Thank you for your contributions!
  * Fix source build after successful build. (Closes: #1044864)

 -- Mo Zhou <lumin@debian.org>  Tue, 19 Dec 2023 19:02:35 -0500

=== debian/control ===
Source: fish
Section: shells
Priority: optional
Maintainer: Mo Zhou <lumin@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               gettext,
               libncurses-dev,
               libpcre2-dev,
               locales-all <!nocheck>,
               ninja-build,
               procps <!nocheck>,
               python3 <!nocheck>,
               python3-sphinx,
               python3-pexpect <!nocheck>,
Standards-Version: 4.6.0
Homepage: http://fishshell.com/
Vcs-Browser: https://salsa.debian.org/debian/fish
Vcs-Git: https://salsa.debian.org/debian/fish.git
Rules-Requires-Root: no

Package: fish
Architecture: any
Depends: fish-common (= ${source:Version}),
         bsdextrautils,
         groff-base,
         man-db,
         procps,
         python3,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: xsel, lynx | www-browser,
Suggests: doc-base
Description: friendly interactive shell
 Fish is a shell geared towards interactive use.  Its features are focused on
 user friendliness and discoverability.  The language syntax is simple but
 incompatible with other shell languages.

Package: fish-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: fish, python3:any
Description: friendly interactive shell (architecture-independent files)
 Fish is a shell geared towards interactive use.  Its features are focused on
 user friendliness and discoverability.  The language syntax is simple but
 incompatible with other shell languages.
 .
 This package contains the common fish files shared by all architectures.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export TERM=xterm
export LC_ALL=C.UTF-8

include /usr/share/dpkg/pkg-info.mk

%:
	dh $@ -Scmake+ninja

execute_after_dh_auto_clean:
	-find . -type d -name '__pycache__' -exec rm -rf '{}' \;

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=RelWithDebInfo

override_dh_install:
	dh_install -XCHANGELOG


ifeq ($(DEB_HOST_ARCH),armel)
override_dh_auto_test:
	dh_auto_test || true
endif

## fish 3.7.1

=== debian/changelog ===
fish (3.7.1-1deepin1) unstable; urgency=medium

  * rustc: Protect against lines starting with - Fixes
    https://github.com/fish-shell/fish-shell/issues/10379

 -- Tianyu Chen <sweetyfish@deepin.org>  Wed, 25 Jun 2025 00:36:25 +0800

fish (3.7.1-1) unstable; urgency=medium

  * New upstream version 3.7.1

 -- Mo Zhou <lumin@debian.org>  Tue, 26 Mar 2024 13:23:19 -0400

## fish 4.0.0

=== debian/changelog ===
fish (4.0.0-3) unstable; urgency=medium

  [ Shengqi Chen ]
  * d/rules: make blhc happy by ignoring Rust crate compiling log

  [ Mo Zhou ]
  * Apply patchset from upstream Integration_4.0.1 branch. (Closes: #1099240)

 -- Mo Zhou <lumin@debian.org>  Mon, 03 Mar 2025 23:13:27 -0500

fish (4.0.0-2) unstable; urgency=medium

  * Use wildcard to figure out build directory instead.
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Fri, 28 Feb 2025 15:33:06 -0500

fish (4.0.0-1) experimental; urgency=medium

  * New upstream version 4.0.0
  * Remove unneeded patches and refresh remaining ones.
  * Update src/signal.rs patch to fix syntax error.
  * The target for tests is fish_run_tests now.
  * Add tmux and git as dependencies for running tests.
  * Patch the wrong Cargo metadata.

 -- Mo Zhou <lumin@debian.org>  Fri, 28 Feb 2025 11:14:38 -0500

fish (4.0~b1-1~exp5) experimental; urgency=medium

  [ Blair Noctis ]
  * Disable SIGSTKFLT on all of mips{,64{,el}}
  * d/control: reorder B-Ds
  * d/patches: drop inline-rsconf, accepted; d/control: add B-D

  [ Mo Zhou ]
  * Insert the changelog for 3.7.1-2 from unstable.

 -- Blair Noctis <ncts@debian.org>  Sun, 29 Dec 2024 12:46:28 +0000

fish (4.0~b1-1~exp4) experimental; urgency=medium

  * Fix build on mips64el which lacks libc::SIGSTKFLT
  * Fix stat segfaults on i386 with librust-libc-dev >= 0.2.169

 -- Blair Noctis <ncts@debian.org>  Sun, 29 Dec 2024 06:33:31 +0000

fish (4.0~b1-1~exp3) experimental; urgency=medium

  * Fix build on certain archs where libc::timespec has private fields due to
    Debian patch
  * Fix build on riscv64 which lacks libc::SIGUNUSED

 -- Blair Noctis <ncts@debian.org>  Sun, 22 Dec 2024 08:06:53 +0000

fish (4.0~b1-1~exp2) experimental; urgency=medium

  * Fix the build for Arch: all. At least make amd64 package installable.

 -- Mo Zhou <lumin@debian.org>  Sat, 21 Dec 2024 23:10:01 -0500

fish (4.0~b1-1~exp1) experimental; urgency=medium

  * New upstream version 4.0b1, to experimental
  * Vendor fish forked pcre2 crate, to be decided with upstream
  * Bump S-V to 4.7.0

  [ Mo Zhou ]
  * Require B-D librust-terminfo-dev (>= 0.9.0~) to avoid unnecessary FTBFS.
  * Patch the version test due to version mangling from 4.0b1 to 4.0~b1.
  * Add ncurses-term to B-D.
  * rules: Delete the .cargo directory on clean.

 -- Blair Noctis <ncts@debian.org>  Thu, 19 Dec 2024 14:53:55 +0000

fish (3.7.1-2) unstable; urgency=medium

  * Skip the broken test against pcre2-10.45. (Closes: #1096221)
    (See:https://github.com/fish-shell/fish-shell/issues/11164)

 -- Mo Zhou <lumin@debian.org>  Mon, 24 Feb 2025 13:22:54 -0500

## fish 4.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")

project(fish LANGUAGES C)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

set(DEFAULT_BUILD_TYPE "RelWithDebInfo")

# Generate Xcode schemas (but not for tests).
set(CMAKE_XCODE_GENERATE_SCHEME 1)

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    message(STATUS "Setting build type to default '${DEFAULT_BUILD_TYPE}'")
    set(CMAKE_BUILD_TYPE "${DEFAULT_BUILD_TYPE}")
endif()

# Set up standard directories.
include(GNUInstallDirs)
add_definitions(-D_UNICODE=1)

include(cmake/gettext.cmake)

# Set up PCRE2
# This sets an environment variable that needs to be available before the Rust stanzas
include(cmake/PCRE2.cmake)

include(cmake/Rust.cmake)

# Work around issue where archive-built libs go in the wrong place.
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})

if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_CURRENT_BINARY_DIR)
  set(FISH_IN_TREE_BUILD TRUE)
else()
  set(FISH_IN_TREE_BUILD FALSE)
endif()

# Set up the machinery around FISH-BUILD-VERSION-FILE
# This defines the FBVF variable.
include(Version)

# Let fish pick up when we're running out of the build directory without installing
get_filename_component(REAL_CMAKE_BINARY_DIR "${CMAKE_BINARY_DIR}" REALPATH)
get_filename_component(REAL_CMAKE_SOURCE_DIR "${CMAKE_SOURCE_DIR}" REALPATH)
add_definitions(-DCMAKE_BINARY_DIR="${REAL_CMAKE_BINARY_DIR}")
add_definitions(-DCMAKE_SOURCE_DIR="${REAL_CMAKE_SOURCE_DIR}")

# Define a function to build and link dependencies.
function(CREATE_TARGET target)
  add_custom_target(
    ${target} ALL
    COMMAND
      "${CMAKE_COMMAND}" -E
        env ${VARS_FOR_CARGO}
          ${Rust_CARGO}
            build --bin ${target}
            $<$<CONFIG:Release>:--release>
            $<$<CONFIG:RelWithDebInfo>:--profile=release-with-debug>
            --target ${Rust_CARGO_TARGET}
            --no-default-features
            ${CARGO_FLAGS}
            ${FEATURES_ARG}
      &&
      "${CMAKE_COMMAND}" -E
        copy "${rust_target_dir}/${rust_profile}/${target}" "${CMAKE_CURRENT_BINARY_DIR}"
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
    USES_TERMINAL
  )
endfunction(CREATE_TARGET)

# Define fish.
create_target(fish)

# Define fish_indent.
create_target(fish_indent)

# Define fish_key_reader.
create_target(fish_key_reader)

# Set up the docs.
include(cmake/Docs.cmake)

# A helper for running tests.
add_executable(fish_test_helper src/fish_test_helper.c)
# Set up tests.
include(cmake/Tests.cmake)

# Benchmarking support.
include(cmake/Benchmark.cmake)

# Set up install.
include(cmake/Install.cmake)

# Mac app.
include(cmake/MacApp.cmake)

include(FeatureSummary)
feature_summary(WHAT ALL)

=== debian/changelog ===
fish (4.0.1-1) unstable; urgency=medium

  * New upstream version 4.0.1
  * Drop cherry-picked patches that are already merged in 4.0.1.
  * Refresh existing patches.

 -- Mo Zhou <lumin@debian.org>  Thu, 13 Mar 2025 19:01:18 -0400

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export TERM=xterm
export LC_ALL=C.UTF-8

include /usr/share/dpkg/pkg-info.mk

# used in build.rs
export FISH_BUILD_VERSION=$(DEB_VERSION_UPSTREAM)

%:
	dh $@ -Scmake+ninja

execute_after_dh_auto_clean:
	-find . -type d -name '__pycache__' -exec rm -rf '{}' \;
	-$(RM) -r .cargo

override_dh_auto_configure:
	mkdir -p .cargo
	cp debian/cargo-config.toml .cargo/config.toml
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=RelWithDebInfo

execute_before_dh_auto_build:
	# blhc treats them as errors
	@echo 'blhc: ignore-line-regexp: .* Compiling v.+ .*'

override_dh_auto_test:
	ninja -C $(firstword $(wildcard obj-*)) fish_run_tests

override_dh_install:
	dh_install -XCHANGELOG

## fish 4.0.2

=== debian/changelog ===
fish (4.0.2-1) unstable; urgency=medium

  * New upstream version 4.0.2
  * Refresh existing patches.

 -- Mo Zhou <lumin@debian.org>  Sun, 20 Apr 2025 13:01:54 -0400

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Section: shells
 Priority: optional
 Maintainer: Mo Zhou <lumin@debian.org>
-Build-Depends: cmake,
-               debhelper-compat (= 13),
+Build-Depends: debhelper-compat (= 13),
+               cargo,
+               cmake,
                gettext,
-               libncurses-dev,
                libpcre2-dev,
                locales-all <!nocheck>,
                ninja-build,
@@ -13,7 +13,28 @@
                python3 <!nocheck>,
                python3-sphinx,
                python3-pexpect <!nocheck>,
-Standards-Version: 4.6.0
+               rustc,
+               librust-bitflags-dev,
+               librust-cc-dev,
+               librust-errno-dev,
+               librust-lazy-static-dev,
+               librust-libc-dev (>= 0.2.169~),
+               librust-lru-dev,
+               librust-nix-dev,
+               librust-num-traits-dev,
+               librust-once-cell-dev,
+               librust-portable-atomic-dev,
+               librust-rand-dev,
+               librust-rsconf-dev,
+               librust-rust-embed-dev,
+               librust-serial-test-dev,
+               librust-tempfile-dev,
+               librust-terminfo-dev (>= 0.9.0~),
+               librust-widestring-dev,
+               ncurses-term,
+               tmux <!nocheck>,
+               git <!nocheck>,
+Standards-Version: 4.7.0
 Homepage: http://fishshell.com/
 Vcs-Browser: https://salsa.debian.org/debian/fish
 Vcs-Git: https://salsa.debian.org/debian/fish.git

=== debian/watch ===
version=4
opts="pgpsigurlmangle=s%$%.asc%,uversionmangle=s/(\d)(\w)(\d)/$1~$2$3/,dversionmangle=s/\+ds$//,repacksuffix=+ds" \
   https://fishshell.com/ \
   (?:.*?)/fish-(\d[\d.]*(?:\w\d+)?)@ARCHIVE_EXT@ debian

## fish 4.0.6

=== debian/changelog ===
fish (4.0.6-0ubuntu1) questing; urgency=medium

  * Merge 4.0.6 from Upstream (LP: #2123819) for recent bug-fixes.
    - d/p/fix-libc-timespec.patch: update to 4.0.6

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Mon, 15 Sep 2025 10:30:02 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: fish
 Section: shells
 Priority: optional
-Maintainer: Mo Zhou <lumin@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Mo Zhou <lumin@debian.org>
 Build-Depends: debhelper-compat (= 13),
                cargo,
                cmake,

## fish 4.2.1

=== debian/changelog ===
fish (4.2.1-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Remove upper limit from serial-test dev-dependency.
    + Thanks to plugwash for the patch. (Closes: #1123794)

 -- Nilesh Patra <nilesh@debian.org>  Sat, 03 Jan 2026 01:35:27 +0530

fish (4.2.1-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Remove broken (inverted) test skip from the previous upload.
  * Make test failures non-fatal. (see #1121178) (Closes: #1121377)

 -- Adrian Bunk <bunk@debian.org>  Sun, 30 Nov 2025 07:20:26 +0200

fish (4.2.1-3) unstable; urgency=medium

  * Skip tests on riscv64, too slow to not have timeouts.
  Closes: #1121377

 -- Blair Noctis <ncts@debian.org>  Tue, 25 Nov 2025 14:19:15 +0000

fish (4.2.1-2) unstable; urgency=medium

  * Reinstate fix-libc-timespec.patch for armhf

 -- Blair Noctis <ncts@debian.org>  Fri, 21 Nov 2025 16:40:34 +0000

fish (4.2.1-1) unstable; urgency=medium

  * New upstream version
  * Drop outdated patches
  * Refresh existing patches
  * Adjust Rust dependency phf to use packaged version
  * Drop Rust dependency unix_path, only used on Windows, not packaged

 -- Blair Noctis <ncts@debian.org>  Thu, 21 Nov 2025 15:18:11 +0000

fish (4.0.2-1.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Mo Zhou ]
  * correct the blhc regex

  [ Peter Green ]
  * Add upstream patch for nix 0.30
  * Tighten debian build-dependency on nix to match Cargo dependency.
    Closes: #1116313

 -- Nilesh Patra <nilesh@debian.org>  Fri, 17 Oct 2025 17:52:00 +0530

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: fish
 Section: shells
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Mo Zhou <lumin@debian.org>
+Maintainer: Mo Zhou <lumin@debian.org>
 Build-Depends: debhelper-compat (= 13),
                cargo,
                cmake,
@@ -21,7 +20,8 @@
                librust-lazy-static-dev,
                librust-libc-dev (>= 0.2.169~),
                librust-lru-dev,
-               librust-nix-dev,
+               librust-macro-rules-attribute-dev,
+               librust-nix-dev (>= 0.30.1-1~),
                librust-num-traits-dev,
                librust-once-cell-dev,
                librust-portable-atomic-dev,
@@ -32,6 +32,7 @@
                librust-tempfile-dev,
                librust-terminfo-dev (>= 0.9.0~),
                librust-widestring-dev,
+               librust-unicode-segmentation-dev,
                ncurses-term,
                tmux <!nocheck>,
                git <!nocheck>,

=== debian/rules ===
--- 
+++ 
@@ -24,10 +24,10 @@
 
 execute_before_dh_auto_build:
 	# blhc treats them as errors
-	@echo 'blhc: ignore-line-regexp: .* Compiling v.+ .*'
+	@echo 'blhc: ignore-line-regexp: .*Compiling\s+[a-zA-Z0-9_-]+\s+v[0-9.]+\s+.*'
 
 override_dh_auto_test:
-	ninja -C $(firstword $(wildcard obj-*)) fish_run_tests
+	-ninja -C $(firstword $(wildcard obj-*)) fish_run_tests
 
 override_dh_install:
 	dh_install -XCHANGELOG

## fish simulator-0.0.5

=== requirements.txt ===
numpy
Pillow
matplotlib
scipy
wheel
twine
black
tqdm
